#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _emp_svc_authentication_tls_certificate_object_info;

struct _EmpSvcAuthenticationTLSCertificateClass {
    GTypeInterface parent_class;
    emp_svc_authentication_tls_certificate_accept_impl accept;
    emp_svc_authentication_tls_certificate_reject_impl reject;
};

enum {
    SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Accepted,
    SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Rejected,
    N_AUTHENTICATION_TLS_CERTIFICATE_SIGNALS
};
static guint authentication_tls_certificate_signals[N_AUTHENTICATION_TLS_CERTIFICATE_SIGNALS] = {0};

static void emp_svc_authentication_tls_certificate_base_init (gpointer klass);

GType
emp_svc_authentication_tls_certificate_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcAuthenticationTLSCertificateClass),
        emp_svc_authentication_tls_certificate_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcAuthenticationTLSCertificate", &info, 0);
    }

  return type;
}

/**
 * emp_svc_authentication_tls_certificate_accept_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Accept on interface org.freedesktop.Telepathy.Authentication.TLSCertificate.
 */
static void
emp_svc_authentication_tls_certificate_accept (EmpSvcAuthenticationTLSCertificate *self,
    DBusGMethodInvocation *context)
{
  emp_svc_authentication_tls_certificate_accept_impl impl = (EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE_GET_CLASS (self)->accept);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_authentication_tls_certificate_implement_accept:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Accept D-Bus method
 *
 * Register an implementation for the Accept method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_authentication_tls_certificate_implement_accept (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_accept_impl impl)
{
  klass->accept = impl;
}

/**
 * emp_svc_authentication_tls_certificate_reject_impl:
 * @self: The object implementing this interface
 * @in_Rejections: const GPtrArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Reject on interface org.freedesktop.Telepathy.Authentication.TLSCertificate.
 */
static void
emp_svc_authentication_tls_certificate_reject (EmpSvcAuthenticationTLSCertificate *self,
    const GPtrArray *in_Rejections,
    DBusGMethodInvocation *context)
{
  emp_svc_authentication_tls_certificate_reject_impl impl = (EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE_GET_CLASS (self)->reject);

  if (impl != NULL)
    {
      (impl) (self,
        in_Rejections,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_authentication_tls_certificate_implement_reject:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Reject D-Bus method
 *
 * Register an implementation for the Reject method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_authentication_tls_certificate_implement_reject (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_reject_impl impl)
{
  klass->reject = impl;
}

/**
 * emp_svc_authentication_tls_certificate_emit_accepted:
 * @instance: The object implementing this interface
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Accepted signal on interface org.freedesktop.Telepathy.Authentication.TLSCertificate.
 */
void
emp_svc_authentication_tls_certificate_emit_accepted (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE));
  g_signal_emit (instance,
      authentication_tls_certificate_signals[SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Accepted],
      0);
}

/**
 * emp_svc_authentication_tls_certificate_emit_rejected:
 * @instance: The object implementing this interface
 * @arg_Rejections: const GPtrArray * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Rejected signal on interface org.freedesktop.Telepathy.Authentication.TLSCertificate.
 */
void
emp_svc_authentication_tls_certificate_emit_rejected (gpointer instance,
    const GPtrArray *arg_Rejections)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE));
  g_signal_emit (instance,
      authentication_tls_certificate_signals[SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Rejected],
      0,
      arg_Rejections);
}

static inline void
emp_svc_authentication_tls_certificate_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[5] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* State */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a(usa{sv})", 0, NULL, NULL }, /* Rejections */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* CertificateType */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "aay", 0, NULL, NULL }, /* CertificateChainData */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Authentication.TLSCertificate");
  properties[0].name = g_quark_from_static_string ("State");
  properties[0].type = G_TYPE_UINT;
  properties[1].name = g_quark_from_static_string ("Rejections");
  properties[1].type = (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID))));
  properties[2].name = g_quark_from_static_string ("CertificateType");
  properties[2].type = G_TYPE_STRING;
  properties[3].name = g_quark_from_static_string ("CertificateChainData");
  properties[3].type = (dbus_g_type_get_collection ("GPtrArray", dbus_g_type_get_collection ("GArray", G_TYPE_UCHAR)));
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE, &interface);

  /**
   * EmpSvcAuthenticationTLSCertificate::accepted:
   *
   * The Accepted D-Bus signal is emitted whenever this GObject signal is.
   */
  authentication_tls_certificate_signals[SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Accepted] =
  g_signal_new ("accepted",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

  /**
   * EmpSvcAuthenticationTLSCertificate::rejected:
   * @arg_Rejections: const GPtrArray * (FIXME, generate documentation)
   *
   * The Rejected D-Bus signal is emitted whenever this GObject signal is.
   */
  authentication_tls_certificate_signals[SIGNAL_AUTHENTICATION_TLS_CERTIFICATE_Rejected] =
  g_signal_new ("rejected",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))));

  dbus_g_object_type_install_info (emp_svc_authentication_tls_certificate_get_type (),
      &_emp_svc_authentication_tls_certificate_object_info);
}
static void
emp_svc_authentication_tls_certificate_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_authentication_tls_certificate_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_authentication_tls_certificate_methods[] = {
  { (GCallback) emp_svc_authentication_tls_certificate_accept, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) emp_svc_authentication_tls_certificate_reject, _emp_ext_marshal_VOID__BOXED_POINTER, 66 },
};

static const DBusGObjectInfo _emp_svc_authentication_tls_certificate_object_info = {
  0,
  _emp_svc_authentication_tls_certificate_methods,
  2,
"org.freedesktop.Telepathy.Authentication.TLSCertificate\0Accept\0A\0\0org.freedesktop.Telepathy.Authentication.TLSCertificate\0Reject\0A\0Rejections\0I\0a(usa{sv})\0\0\0",
"org.freedesktop.Telepathy.Authentication.TLSCertificate\0Accepted\0org.freedesktop.Telepathy.Authentication.TLSCertificate\0Rejected\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_channel_interface_conference_object_info;

struct _EmpSvcChannelInterfaceConferenceClass {
    GTypeInterface parent_class;
};

enum {
    SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelMerged,
    SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelRemoved,
    N_CHANNEL_INTERFACE_CONFERENCE_SIGNALS
};
static guint channel_interface_conference_signals[N_CHANNEL_INTERFACE_CONFERENCE_SIGNALS] = {0};

static void emp_svc_channel_interface_conference_base_init (gpointer klass);

GType
emp_svc_channel_interface_conference_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelInterfaceConferenceClass),
        emp_svc_channel_interface_conference_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelInterfaceConference", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_interface_conference_emit_channel_merged:
 * @instance: The object implementing this interface
 * @arg_Channel: const gchar * (FIXME, generate documentation)
 * @arg_Channel_Specific_Handle: guint  (FIXME, generate documentation)
 * @arg_Properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ChannelMerged signal on interface org.freedesktop.Telepathy.Channel.Interface.Conference.
 */
void
emp_svc_channel_interface_conference_emit_channel_merged (gpointer instance,
    const gchar *arg_Channel,
    guint arg_Channel_Specific_Handle,
    GHashTable *arg_Properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE));
  g_signal_emit (instance,
      channel_interface_conference_signals[SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelMerged],
      0,
      arg_Channel,
      arg_Channel_Specific_Handle,
      arg_Properties);
}

/**
 * emp_svc_channel_interface_conference_emit_channel_removed:
 * @instance: The object implementing this interface
 * @arg_Channel: const gchar * (FIXME, generate documentation)
 * @arg_Details: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ChannelRemoved signal on interface org.freedesktop.Telepathy.Channel.Interface.Conference.
 */
void
emp_svc_channel_interface_conference_emit_channel_removed (gpointer instance,
    const gchar *arg_Channel,
    GHashTable *arg_Details)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE));
  g_signal_emit (instance,
      channel_interface_conference_signals[SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelRemoved],
      0,
      arg_Channel,
      arg_Details);
}

static inline void
emp_svc_channel_interface_conference_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[7] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "ao", 0, NULL, NULL }, /* Channels */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "ao", 0, NULL, NULL }, /* InitialChannels */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "au", 0, NULL, NULL }, /* InitialInviteeHandles */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* InitialInviteeIDs */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* InvitationMessage */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{uo}", 0, NULL, NULL }, /* OriginalChannels */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Interface.Conference");
  properties[0].name = g_quark_from_static_string ("Channels");
  properties[0].type = dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH);
  properties[1].name = g_quark_from_static_string ("InitialChannels");
  properties[1].type = dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH);
  properties[2].name = g_quark_from_static_string ("InitialInviteeHandles");
  properties[2].type = DBUS_TYPE_G_UINT_ARRAY;
  properties[3].name = g_quark_from_static_string ("InitialInviteeIDs");
  properties[3].type = G_TYPE_STRV;
  properties[4].name = g_quark_from_static_string ("InvitationMessage");
  properties[4].type = G_TYPE_STRING;
  properties[5].name = g_quark_from_static_string ("OriginalChannels");
  properties[5].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, DBUS_TYPE_G_OBJECT_PATH));
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE, &interface);

  /**
   * EmpSvcChannelInterfaceConference::channel-merged:
   * @arg_Channel: const gchar * (FIXME, generate documentation)
   * @arg_Channel_Specific_Handle: guint  (FIXME, generate documentation)
   * @arg_Properties: GHashTable * (FIXME, generate documentation)
   *
   * The ChannelMerged D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_interface_conference_signals[SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelMerged] =
  g_signal_new ("channel-merged",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_UINT_BOXED,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  /**
   * EmpSvcChannelInterfaceConference::channel-removed:
   * @arg_Channel: const gchar * (FIXME, generate documentation)
   * @arg_Details: GHashTable * (FIXME, generate documentation)
   *
   * The ChannelRemoved D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_interface_conference_signals[SIGNAL_CHANNEL_INTERFACE_CONFERENCE_ChannelRemoved] =
  g_signal_new ("channel-removed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      DBUS_TYPE_G_OBJECT_PATH,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  dbus_g_object_type_install_info (emp_svc_channel_interface_conference_get_type (),
      &_emp_svc_channel_interface_conference_object_info);
}
static void
emp_svc_channel_interface_conference_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_interface_conference_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_interface_conference_methods[] = {
};

static const DBusGObjectInfo _emp_svc_channel_interface_conference_object_info = {
  0,
  _emp_svc_channel_interface_conference_methods,
  0,
"\0",
"org.freedesktop.Telepathy.Channel.Interface.Conference\0ChannelMerged\0org.freedesktop.Telepathy.Channel.Interface.Conference\0ChannelRemoved\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_channel_type_server_tls_connection_object_info;

struct _EmpSvcChannelTypeServerTLSConnectionClass {
    GTypeInterface parent_class;
};

static void emp_svc_channel_type_server_tls_connection_base_init (gpointer klass);

GType
emp_svc_channel_type_server_tls_connection_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelTypeServerTLSConnectionClass),
        emp_svc_channel_type_server_tls_connection_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelTypeServerTLSConnection", &info, 0);
    }

  return type;
}

static inline void
emp_svc_channel_type_server_tls_connection_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "o", 0, NULL, NULL }, /* ServerCertificate */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* Hostname */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.ServerTLSConnection");
  properties[0].name = g_quark_from_static_string ("ServerCertificate");
  properties[0].type = DBUS_TYPE_G_OBJECT_PATH;
  properties[1].name = g_quark_from_static_string ("Hostname");
  properties[1].type = G_TYPE_STRING;
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION, &interface);

  dbus_g_object_type_install_info (emp_svc_channel_type_server_tls_connection_get_type (),
      &_emp_svc_channel_type_server_tls_connection_object_info);
}
static void
emp_svc_channel_type_server_tls_connection_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_type_server_tls_connection_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_type_server_tls_connection_methods[] = {
};

static const DBusGObjectInfo _emp_svc_channel_type_server_tls_connection_object_info = {
  0,
  _emp_svc_channel_type_server_tls_connection_methods,
  0,
"\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_debug_object_info;

struct _EmpSvcDebugClass {
    GTypeInterface parent_class;
    emp_svc_debug_get_messages_impl get_messages;
};

enum {
    SIGNAL_DEBUG_NewDebugMessage,
    N_DEBUG_SIGNALS
};
static guint debug_signals[N_DEBUG_SIGNALS] = {0};

static void emp_svc_debug_base_init (gpointer klass);

GType
emp_svc_debug_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcDebugClass),
        emp_svc_debug_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcDebug", &info, 0);
    }

  return type;
}

/**
 * emp_svc_debug_get_messages_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetMessages on interface org.freedesktop.Telepathy.Debug.
 */
static void
emp_svc_debug_get_messages (EmpSvcDebug *self,
    DBusGMethodInvocation *context)
{
  emp_svc_debug_get_messages_impl impl = (EMP_SVC_DEBUG_GET_CLASS (self)->get_messages);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_debug_implement_get_messages:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetMessages D-Bus method
 *
 * Register an implementation for the GetMessages method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_debug_implement_get_messages (EmpSvcDebugClass *klass, emp_svc_debug_get_messages_impl impl)
{
  klass->get_messages = impl;
}

/**
 * emp_svc_debug_emit_new_debug_message:
 * @instance: The object implementing this interface
 * @arg_time: gdouble  (FIXME, generate documentation)
 * @arg_domain: const gchar * (FIXME, generate documentation)
 * @arg_level: guint  (FIXME, generate documentation)
 * @arg_message: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * NewDebugMessage signal on interface org.freedesktop.Telepathy.Debug.
 */
void
emp_svc_debug_emit_new_debug_message (gpointer instance,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_DEBUG));
  g_signal_emit (instance,
      debug_signals[SIGNAL_DEBUG_NewDebugMessage],
      0,
      arg_time,
      arg_domain,
      arg_level,
      arg_message);
}

static inline void
emp_svc_debug_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ | TP_DBUS_PROPERTIES_MIXIN_FLAG_WRITE, "b", 0, NULL, NULL }, /* Enabled */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Debug");
  properties[0].name = g_quark_from_static_string ("Enabled");
  properties[0].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_DEBUG, &interface);

  /**
   * EmpSvcDebug::new-debug-message:
   * @arg_time: gdouble  (FIXME, generate documentation)
   * @arg_domain: const gchar * (FIXME, generate documentation)
   * @arg_level: guint  (FIXME, generate documentation)
   * @arg_message: const gchar * (FIXME, generate documentation)
   *
   * The NewDebugMessage D-Bus signal is emitted whenever this GObject signal is.
   */
  debug_signals[SIGNAL_DEBUG_NewDebugMessage] =
  g_signal_new ("new-debug-message",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__DOUBLE_STRING_UINT_STRING,
      G_TYPE_NONE,
      4,
      G_TYPE_DOUBLE,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_STRING);

  dbus_g_object_type_install_info (emp_svc_debug_get_type (),
      &_emp_svc_debug_object_info);
}
static void
emp_svc_debug_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_debug_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_debug_methods[] = {
  { (GCallback) emp_svc_debug_get_messages, g_cclosure_marshal_VOID__POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_debug_object_info = {
  0,
  _emp_svc_debug_methods,
  1,
"org.freedesktop.Telepathy.Debug\0GetMessages\0A\0Messages\0O\0F\0N\0a(dsus)\0\0\0",
"org.freedesktop.Telepathy.Debug\0NewDebugMessage\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_logger_object_info;

struct _EmpSvcLoggerClass {
    GTypeInterface parent_class;
    emp_svc_logger_get_recent_messages_impl get_recent_messages;
    emp_svc_logger_get_favourite_contacts_impl get_favourite_contacts;
    emp_svc_logger_add_favourite_contact_impl add_favourite_contact;
    emp_svc_logger_remove_favourite_contact_impl remove_favourite_contact;
};

enum {
    SIGNAL_LOGGER_FavouriteContactsChanged,
    N_LOGGER_SIGNALS
};
static guint logger_signals[N_LOGGER_SIGNALS] = {0};

static void emp_svc_logger_base_init (gpointer klass);

GType
emp_svc_logger_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcLoggerClass),
        emp_svc_logger_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcLogger", &info, 0);
    }

  return type;
}

/**
 * emp_svc_logger_get_recent_messages_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @in_Is_Chatroom: gboolean  (FIXME, generate documentation)
 * @in_Lines: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetRecentMessages on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
emp_svc_logger_get_recent_messages (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gboolean in_Is_Chatroom,
    guint in_Lines,
    DBusGMethodInvocation *context)
{
  emp_svc_logger_get_recent_messages_impl impl = (EMP_SVC_LOGGER_GET_CLASS (self)->get_recent_messages);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        in_Is_Chatroom,
        in_Lines,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_logger_implement_get_recent_messages:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetRecentMessages D-Bus method
 *
 * Register an implementation for the GetRecentMessages method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_logger_implement_get_recent_messages (EmpSvcLoggerClass *klass, emp_svc_logger_get_recent_messages_impl impl)
{
  klass->get_recent_messages = impl;
}

/**
 * emp_svc_logger_get_favourite_contacts_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetFavouriteContacts on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
emp_svc_logger_get_favourite_contacts (EmpSvcLogger *self,
    DBusGMethodInvocation *context)
{
  emp_svc_logger_get_favourite_contacts_impl impl = (EMP_SVC_LOGGER_GET_CLASS (self)->get_favourite_contacts);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_logger_implement_get_favourite_contacts:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetFavouriteContacts D-Bus method
 *
 * Register an implementation for the GetFavouriteContacts method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_logger_implement_get_favourite_contacts (EmpSvcLoggerClass *klass, emp_svc_logger_get_favourite_contacts_impl impl)
{
  klass->get_favourite_contacts = impl;
}

/**
 * emp_svc_logger_add_favourite_contact_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AddFavouriteContact on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
emp_svc_logger_add_favourite_contact (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context)
{
  emp_svc_logger_add_favourite_contact_impl impl = (EMP_SVC_LOGGER_GET_CLASS (self)->add_favourite_contact);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_logger_implement_add_favourite_contact:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AddFavouriteContact D-Bus method
 *
 * Register an implementation for the AddFavouriteContact method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_logger_implement_add_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_add_favourite_contact_impl impl)
{
  klass->add_favourite_contact = impl;
}

/**
 * emp_svc_logger_remove_favourite_contact_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Identifier: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RemoveFavouriteContact on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
static void
emp_svc_logger_remove_favourite_contact (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context)
{
  emp_svc_logger_remove_favourite_contact_impl impl = (EMP_SVC_LOGGER_GET_CLASS (self)->remove_favourite_contact);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Identifier,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_logger_implement_remove_favourite_contact:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RemoveFavouriteContact D-Bus method
 *
 * Register an implementation for the RemoveFavouriteContact method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_logger_implement_remove_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_remove_favourite_contact_impl impl)
{
  klass->remove_favourite_contact = impl;
}

/**
 * emp_svc_logger_emit_favourite_contacts_changed:
 * @instance: The object implementing this interface
 * @arg_Account: const gchar * (FIXME, generate documentation)
 * @arg_Added: const gchar ** (FIXME, generate documentation)
 * @arg_Removed: const gchar ** (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * FavouriteContactsChanged signal on interface org.freedesktop.Telepathy.Logger.DRAFT.
 */
void
emp_svc_logger_emit_favourite_contacts_changed (gpointer instance,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_LOGGER));
  g_signal_emit (instance,
      logger_signals[SIGNAL_LOGGER_FavouriteContactsChanged],
      0,
      arg_Account,
      arg_Added,
      arg_Removed);
}

static inline void
emp_svc_logger_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Logger.DRAFT");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_LOGGER, &interface);

  /**
   * EmpSvcLogger::favourite-contacts-changed:
   * @arg_Account: const gchar * (FIXME, generate documentation)
   * @arg_Added: const gchar ** (FIXME, generate documentation)
   * @arg_Removed: const gchar ** (FIXME, generate documentation)
   *
   * The FavouriteContactsChanged D-Bus signal is emitted whenever this GObject signal is.
   */
  logger_signals[SIGNAL_LOGGER_FavouriteContactsChanged] =
  g_signal_new ("favourite-contacts-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_BOXED_BOXED,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_STRV,
      G_TYPE_STRV);

  dbus_g_object_type_install_info (emp_svc_logger_get_type (),
      &_emp_svc_logger_object_info);
}
static void
emp_svc_logger_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_logger_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_logger_methods[] = {
  { (GCallback) emp_svc_logger_get_recent_messages, _emp_ext_marshal_VOID__BOXED_STRING_BOOLEAN_UINT_POINTER, 0 },
  { (GCallback) emp_svc_logger_get_favourite_contacts, g_cclosure_marshal_VOID__POINTER, 135 },
  { (GCallback) emp_svc_logger_add_favourite_contact, _emp_ext_marshal_VOID__BOXED_STRING_POINTER, 230 },
  { (GCallback) emp_svc_logger_remove_favourite_contact, _emp_ext_marshal_VOID__BOXED_STRING_POINTER, 319 },
};

static const DBusGObjectInfo _emp_svc_logger_object_info = {
  0,
  _emp_svc_logger_methods,
  4,
"org.freedesktop.Telepathy.Logger.DRAFT\0GetRecentMessages\0A\0Account\0I\0o\0Identifier\0I\0s\0Is_Chatroom\0I\0b\0Lines\0I\0u\0Messages\0O\0F\0N\0a(ssx)\0\0org.freedesktop.Telepathy.Logger.DRAFT\0GetFavouriteContacts\0A\0Favourite_Contacts\0O\0F\0N\0a(oas)\0\0org.freedesktop.Telepathy.Logger.DRAFT\0AddFavouriteContact\0A\0Account\0I\0o\0Identifier\0I\0s\0\0org.freedesktop.Telepathy.Logger.DRAFT\0RemoveFavouriteContact\0A\0Account\0I\0o\0Identifier\0I\0s\0\0\0",
"org.freedesktop.Telepathy.Logger.DRAFT\0FavouriteContactsChanged\0\0",
"\0\0",
};


