#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * EmpSvcAuthenticationTLSCertificate:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcAuthenticationTLSCertificate EmpSvcAuthenticationTLSCertificate;

/**
 * EmpSvcAuthenticationTLSCertificateClass:
 *
 * The class of EmpSvcAuthenticationTLSCertificate.
 */
typedef struct _EmpSvcAuthenticationTLSCertificateClass EmpSvcAuthenticationTLSCertificateClass;

GType emp_svc_authentication_tls_certificate_get_type (void);
#define EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE \
  (emp_svc_authentication_tls_certificate_get_type ())
#define EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE, EmpSvcAuthenticationTLSCertificate))
#define EMP_IS_SVC_AUTHENTICATION_TLS_CERTIFICATE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE))
#define EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE, EmpSvcAuthenticationTLSCertificateClass))


typedef void (*emp_svc_authentication_tls_certificate_accept_impl) (EmpSvcAuthenticationTLSCertificate *self,
    DBusGMethodInvocation *context);
void emp_svc_authentication_tls_certificate_implement_accept (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_accept_impl impl);
/**
 * emp_svc_authentication_tls_certificate_return_from_accept:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_authentication_tls_certificate_return_from_accept (DBusGMethodInvocation *context);
static inline void
emp_svc_authentication_tls_certificate_return_from_accept (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_authentication_tls_certificate_reject_impl) (EmpSvcAuthenticationTLSCertificate *self,
    const GPtrArray *in_Rejections,
    DBusGMethodInvocation *context);
void emp_svc_authentication_tls_certificate_implement_reject (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_reject_impl impl);
/**
 * emp_svc_authentication_tls_certificate_return_from_reject:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_authentication_tls_certificate_return_from_reject (DBusGMethodInvocation *context);
static inline void
emp_svc_authentication_tls_certificate_return_from_reject (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_authentication_tls_certificate_emit_accepted (gpointer instance);
void emp_svc_authentication_tls_certificate_emit_rejected (gpointer instance,
    const GPtrArray *arg_Rejections);

/**
 * EmpSvcChannelInterfaceConference:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelInterfaceConference EmpSvcChannelInterfaceConference;

/**
 * EmpSvcChannelInterfaceConferenceClass:
 *
 * The class of EmpSvcChannelInterfaceConference.
 */
typedef struct _EmpSvcChannelInterfaceConferenceClass EmpSvcChannelInterfaceConferenceClass;

GType emp_svc_channel_interface_conference_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE \
  (emp_svc_channel_interface_conference_get_type ())
#define EMP_SVC_CHANNEL_INTERFACE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE, EmpSvcChannelInterfaceConference))
#define EMP_IS_SVC_CHANNEL_INTERFACE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE))
#define EMP_SVC_CHANNEL_INTERFACE_CONFERENCE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CONFERENCE, EmpSvcChannelInterfaceConferenceClass))


void emp_svc_channel_interface_conference_emit_channel_merged (gpointer instance,
    const gchar *arg_Channel,
    guint arg_Channel_Specific_Handle,
    GHashTable *arg_Properties);
void emp_svc_channel_interface_conference_emit_channel_removed (gpointer instance,
    const gchar *arg_Channel,
    GHashTable *arg_Details);

/**
 * EmpSvcChannelTypeServerTLSConnection:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelTypeServerTLSConnection EmpSvcChannelTypeServerTLSConnection;

/**
 * EmpSvcChannelTypeServerTLSConnectionClass:
 *
 * The class of EmpSvcChannelTypeServerTLSConnection.
 */
typedef struct _EmpSvcChannelTypeServerTLSConnectionClass EmpSvcChannelTypeServerTLSConnectionClass;

GType emp_svc_channel_type_server_tls_connection_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION \
  (emp_svc_channel_type_server_tls_connection_get_type ())
#define EMP_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION, EmpSvcChannelTypeServerTLSConnection))
#define EMP_IS_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION))
#define EMP_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION, EmpSvcChannelTypeServerTLSConnectionClass))



/**
 * EmpSvcDebug:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcDebug EmpSvcDebug;

/**
 * EmpSvcDebugClass:
 *
 * The class of EmpSvcDebug.
 */
typedef struct _EmpSvcDebugClass EmpSvcDebugClass;

GType emp_svc_debug_get_type (void);
#define EMP_TYPE_SVC_DEBUG \
  (emp_svc_debug_get_type ())
#define EMP_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebug))
#define EMP_IS_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_DEBUG))
#define EMP_SVC_DEBUG_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebugClass))


typedef void (*emp_svc_debug_get_messages_impl) (EmpSvcDebug *self,
    DBusGMethodInvocation *context);
void emp_svc_debug_implement_get_messages (EmpSvcDebugClass *klass, emp_svc_debug_get_messages_impl impl);
/**
 * emp_svc_debug_return_from_get_messages:
 * @context: The D-Bus method invocation context
 * @out_Messages: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages);
static inline void
emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages)
{
  dbus_g_method_return (context,
      out_Messages);
}

void emp_svc_debug_emit_new_debug_message (gpointer instance,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message);

/**
 * EmpSvcLogger:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcLogger EmpSvcLogger;

/**
 * EmpSvcLoggerClass:
 *
 * The class of EmpSvcLogger.
 */
typedef struct _EmpSvcLoggerClass EmpSvcLoggerClass;

GType emp_svc_logger_get_type (void);
#define EMP_TYPE_SVC_LOGGER \
  (emp_svc_logger_get_type ())
#define EMP_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLogger))
#define EMP_IS_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_LOGGER))
#define EMP_SVC_LOGGER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLoggerClass))


typedef void (*emp_svc_logger_get_recent_messages_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gboolean in_Is_Chatroom,
    guint in_Lines,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_get_recent_messages (EmpSvcLoggerClass *klass, emp_svc_logger_get_recent_messages_impl impl);
/**
 * emp_svc_logger_return_from_get_recent_messages:
 * @context: The D-Bus method invocation context
 * @out_Messages: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_get_recent_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages);
static inline void
emp_svc_logger_return_from_get_recent_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages)
{
  dbus_g_method_return (context,
      out_Messages);
}

typedef void (*emp_svc_logger_get_favourite_contacts_impl) (EmpSvcLogger *self,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_get_favourite_contacts (EmpSvcLoggerClass *klass, emp_svc_logger_get_favourite_contacts_impl impl);
/**
 * emp_svc_logger_return_from_get_favourite_contacts:
 * @context: The D-Bus method invocation context
 * @out_Favourite_Contacts: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts);
static inline void
emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts)
{
  dbus_g_method_return (context,
      out_Favourite_Contacts);
}

typedef void (*emp_svc_logger_add_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_add_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_add_favourite_contact_impl impl);
/**
 * emp_svc_logger_return_from_add_favourite_contact:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_remove_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_remove_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_remove_favourite_contact_impl impl);
/**
 * emp_svc_logger_return_from_remove_favourite_contact:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_logger_emit_favourite_contacts_changed (gpointer instance,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed);


G_END_DECLS
